#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=rr.ico
#AutoIt3Wrapper_outfile=RRSliderUpdater.exe
#AutoIt3Wrapper_Compression=4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

FileInstall("D:\Program Files\Ride Runner\Skins\Carwings_Dynamic_pm_new\Scripts\OverlayMenu\up.bmp",@TempDir&"\up.bmp",1)
FileInstall("D:\Program Files\Ride Runner\Skins\Carwings_Dynamic_pm_new\Scripts\OverlayMenu\down.bmp",@TempDir&"\down.bmp",1)
FileInstall("D:\Program Files\Ride Runner\Skins\Carwings_Dynamic_pm_new\Scripts\OverlayMenu\loop.bmp",@TempDir&"\loop.bmp",1)
$rr = ObjCreate("RoadRunner.SDK")
Local $TITRE = "RRSliders Updater for RideRunner"
Local $NOMBRE = 6

Local $Inputs_Name[$NOMBRE] ; Liste des inputs pour les "Indicator Name" et les "Slider Name"
Local $Inputs_Value[$NOMBRE] ; Liste des inputs pour les "Indicator Value" et les "Slider Value"
Local $Buttons_Choice[$NOMBRE] ; Liste des boutons permettant le type d'update(de bas en haut(1),de haut en bas(2) ou de bas en haut en continu(3))
Local $Buttons[$NOMBRE] ; Liste des boutons "Send Command" pour les "Indicators" et les "Sliders"
Local $UpdateType = 1
Local $UpdatePicType = "\up.bmp"

$Form1 = GUICreate($TITRE, 635, 323, @DesktopWidth-645, 5)
;#cs
$Group1 = GUICtrlCreateGroup(" Sliders Update - 1 ", 16, 8, 601, 121)
For $i = 0 To $NOMBRE/2-1
    GUICtrlCreateLabel("Slider Name :",       24, 32+32*$i,  82, 17)
    $Inputs_Name[$i] = GUICtrlCreateInput("",   90, 32+32*$i, 113, 21)
    GUICtrlCreateLabel("Slider Value :",     232, 32+32*$i,  82, 17)
    $Inputs_Value[$i] = GUICtrlCreateInput("-", 298, 32+32*$i, 113, 21)
	$Buttons_Choice[$i] = GUICtrlCreateButton("Choice", 440, 32+32*$i, 50, 25, BitOR($WS_GROUP, $BS_DEFPUSHBUTTON,$BS_BITMAP))
	GUICtrlSetImage($Buttons_Choice[$i], @TempDir & $UpdatePicType, -1,0)
	GUICtrlSetTip($Buttons_Choice[$i],"Choose a type of update !")
    $Buttons[$i] = GUICtrlCreateButton("Send Command", 500, 32+32*$i, 100, 25, $WS_GROUP)
Next
GUICtrlSetData($Inputs_Name[0], "DFXSPEED")
;#ce
;#cs
$Group2 = GUICtrlCreateGroup(" Sliders Update - 2 ", 16, 136, 601, 121)
For $i = $NOMBRE/2 To $NOMBRE-1
    GUICtrlCreateLabel("Slider Name :",          24, 64+32*$i,  82, 17)
    $Inputs_Name[$i] = GUICtrlCreateInput("",   90, 64+32*$i, 113, 21)
    GUICtrlCreateLabel("Slider Value :",        232, 64+32*$i,  82, 17)
    $Inputs_Value[$i] = GUICtrlCreateInput("-", 298, 64+32*$i, 113, 21)
	$Buttons_Choice[$i] = GUICtrlCreateButton("Choice", 440, 64+32*$i, 50, 25, BitOR($WS_GROUP, $BS_DEFPUSHBUTTON,$BS_BITMAP))
	GUICtrlSetImage($Buttons_Choice[$i], @TempDir & $UpdatePicType, -1,0)
	GUICtrlSetTip($Buttons_Choice[$i],"Choose a type of update !")
    $Buttons[$i] = GUICtrlCreateButton("Send Command", 500, 64+32*$i, 100, 25, $WS_GROUP)
Next
GUICtrlSetData($Inputs_Name[3], "DFXSPEED")
;#ce
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Button7 = GUICtrlCreateButton("Exit", 500, 272, 100, 33, $WS_GROUP)

GUISetState(@SW_SHOW)

Local $stop = False
While Not $stop
    $msg = GUIGetMsg()
    If $msg = $GUI_EVENT_CLOSE Or $msg = $Button7 Then
        $stop = True
    Else
        For $i = 0 To $NOMBRE-1
            GUICtrlSetStateIfNotAlready($Buttons[$i],cond(GUICtrlRead($Inputs_Name[$i])="",$GUI_DISABLE,$GUI_ENABLE))
        Next
        For $i = 0 To $NOMBRE-1
            If $msg = $Buttons_Choice[$i] Then
				Switch $UpdateType
					Case 1;"Up"
						GUICtrlSetImage($Buttons_Choice[$i], @TempDir & "\down.bmp", -1,0)
						$UpdateType = 2
					Case 2;"Down"
						GUICtrlSetImage($Buttons_Choice[$i], @TempDir & "\Loop.bmp", -1,0)
						$UpdateType = 3
					Case 3;"Loop"
						GUICtrlSetImage($Buttons_Choice[$i], @TempDir & "\up.bmp", -1,0)
						$UpdateType = 1
				EndSwitch
			EndIf
        Next
        For $i = 0 To $NOMBRE-1
            If $msg = $Buttons[$i] Then
                Local $texte_Button = GUICtrlRead($Buttons[$i])
                GUICtrlSetData($Buttons[$i],"Stop Command")
                For $k = 0 To $NOMBRE-1
                    If ($k<$NOMBRE/2 And $i<$NOMBRE/2) Or ($k>=$NOMBRE/2 And $i>=$NOMBRE/2) Then
                        GUICtrlSetStateIfNotAlready($Buttons[$k],cond($i=$k,$GUI_ENABLE,$GUI_DISABLE))
                    EndIf
                Next
				If $UpdateType = 1 Then
					$UpdatePicType = "\up.bmp"
					For $k= 0 to 65535 Step Round(65535/20,0)
						$rr.execute("SETVAR;"&GUICtrlRead($Inputs_Name[$i])&";"&$k)
						GUICtrlSetData($Inputs_Value[$i],$k)
						Local $timer = TimerInit()
						Do
							$msg = GUIGetMsg()
							$stop = ($msg = $GUI_EVENT_CLOSE Or $msg = $Button7 Or $msg = $Buttons[$i])
						Until TimerDiff($timer)>2000 Or $stop
						If $stop Then
							If $msg = $Buttons[$i] Then
								TrayTip($TITRE,"The variable "&GuiCtrlRead($Inputs_Name[$i])&" is stopped at " & GuiCtrlRead($Inputs_Value[$i]),30,2)
								$stop = False
							EndIf
							ExitLoop
					   EndIf
					Next
				ElseIf $UpdateType = 2 Then
					$UpdatePicType = "\down.bmp"
					For $k= 65535 to 0 Step -Round(65535/20,0)
						$rr.execute("SETVAR;"&GUICtrlRead($Inputs_Name[$i])&";"&$k)
						GUICtrlSetData($Inputs_Value[$i],$k)
						Local $timer = TimerInit()
						Do
							$msg = GUIGetMsg()
							$stop = ($msg = $GUI_EVENT_CLOSE Or $msg = $Button7 Or $msg = $Buttons[$i])
						Until TimerDiff($timer)>2000 Or $stop
						If $stop Then
							If $msg = $Buttons[$i] Then
								TrayTip($TITRE,"The variable "&GuiCtrlRead($Inputs_Name[$i])&" is stopped at " & GuiCtrlRead($Inputs_Value[$i]),30,2)
								$stop = False
							EndIf
							ExitLoop
					   EndIf
					Next
				ElseIf $UpdateType = 3 Then
					$UpdatePicType = "\Loop.bmp"
					While Not $stop
					For $k = 0 To $NOMBRE-1
						If ($k<$NOMBRE/2 And $i<$NOMBRE/2) Or ($k>=$NOMBRE/2 And $i>=$NOMBRE/2) Then
							GUICtrlSetStateIfNotAlready($Buttons[$k],cond($i=$k,$GUI_ENABLE,$GUI_DISABLE))
						EndIf
					Next
					For $k= 0 to 65535 Step Round(65535/20,0)
						$rr.execute("SETVAR;"&GUICtrlRead($Inputs_Name[$i])&";"&$k)
						GUICtrlSetData($Inputs_Value[$i],$k)
						Local $timer = TimerInit()
						Do
							$msg = GUIGetMsg()
							$stop = ($msg = $GUI_EVENT_CLOSE Or $msg = $Button7 Or $msg = $Buttons[$i])
						Until TimerDiff($timer)>2000 Or $stop
						If $stop Then
							If $msg = $Buttons[$i] Then
								TrayTip($TITRE,"The variable "&GuiCtrlRead($Inputs_Name[$i])&" is stopped at " & GuiCtrlRead($Inputs_Value[$i]),30,2)
								$stop = False
							EndIf
							ExitLoop
					   EndIf
					Next
					For $k= 65535 to 0 Step -Round(65535/20,0)
						$rr.execute("SETVAR;"&GUICtrlRead($Inputs_Name[$i])&";"&$k)
						GUICtrlSetData($Inputs_Value[$i],$k)
						Local $timer = TimerInit()
						Do
							$msg = GUIGetMsg()
							$stop = ($msg = $GUI_EVENT_CLOSE Or $msg = $Button7 Or $msg = $Buttons[$i])
						Until TimerDiff($timer)>2000 Or $stop
						If $stop Then
							If $msg = $Buttons[$i] Then
								TrayTip($TITRE,"The variable "&GuiCtrlRead($Inputs_Name[$i])&" is stopped at " & GuiCtrlRead($Inputs_Value[$i]),30,2)
								$stop = False
							EndIf
							ExitLoop
					   EndIf
					Next
					Wend
				EndIf
                GUICtrlSetData($Buttons[$i],$texte_Button)
            EndIf
        Next
    EndIf
WEnd

Func cond($cond, $true, $false)
    If $cond Then Return $true
    Return $false
EndFunc

Func GUICtrlSetStateIfNotAlready($control,$state)
    If BitAND(GUICtrlGetState($control),$state) <> $state Then
        GUICtrlSetState($control, $state)
    EndIf
EndFunc